package net.mcbat.LightningEvent;

import java.util.logging.Logger;

import org.bukkit.Location;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.java.JavaPlugin;

import com.nijiko.permissions.PermissionHandler;
import com.nijikokun.bukkit.Permissions.Permissions;

import net.mcbat.LightningEvent.Listeners.LightningEventEntityListener;
import net.mcbat.LightningEvent.Listeners.LightningEventPlayerListener;
import net.mcbat.LightningEvent.Listeners.LightningEventServerListener;

public class LightningEvent extends JavaPlugin {
	private final Logger _logger;

	public PermissionHandler Permissions = null;
	
	public LightningEvent() {
		_logger = Logger.getLogger("Minecraft");
	}

	@Override
	public void onEnable() {
		_logger.info("[LightningEvent] v"+this.getDescription().getVersion()+" (Helium) loaded.");
		_logger.info("[LightningEvent] Developed by: [Mattera, Steven (IchigoKyger)]");
		
		if (Permissions == null) {
			Plugin PermissionsPlugin = this.getServer().getPluginManager().getPlugin("Permissions");
			
			if (PermissionsPlugin != null) {
				if (PermissionsPlugin.isEnabled()) {
					Permissions = ((Permissions) PermissionsPlugin).getHandler();
					_logger.info("[LightningEvent] hooked into Permissions/GroupManager.");
				}
			}
		}
		
		(new LightningEventEntityListener(this)).registerEvents();
		(new LightningEventPlayerListener(this)).registerEvents();
		(new LightningEventServerListener(this)).registerEvents();
	}
	
	@Override
	public void onDisable() {
		_logger.info("[LightningEvent] Plugin disabled.");
	}
	
	public Logger getMinecraftLogger() {
		return _logger;
	}
	
	public void castLightningAtLocation(Location location) {
		location.getWorld().strikeLightningEffect(location);
	}
}
